import '../polyfill';
import '../deprecate';
import Control, { ControlProps } from '../Control';
import '../../css/DateTime.css';
import '../../css/Text.css';
type DateTimeProps = ControlProps & {
    value?: Date | null;
    type?: 'date' | 'time' | 'datetime';
    locale?: 'ja' | 'en' | 'zh';
    dateFormat?: string;
    timeFormat?: string;
    onChange?: (date: Date) => void;
};
declare class DateTime extends Control<DateTimeProps> {
    protected element: HTMLElement;
    private _dateTextInput;
    private _timeTextInput;
    private _dateErrorDiv;
    private _calendar;
    private _locale;
    private _timePicker;
    private _time;
    constructor(params?: DateTimeProps);
    render(): HTMLElement;
    rerender(changedAttr: string[]): void;
    private _renderContainer;
    private _renderDateInputErrorLabel;
    private _renderDateTextInput;
    private _renderTimeTextInput;
    private _registerTimeTextInputEvents;
    private _setTextInputValueToPreviousValidValue;
    private _setTimeValueOnInput;
    private _changeMinutesBy;
    private _changeHoursBy;
    private _renderDate;
    private _renderTime;
    private _renderDateTime;
    private _checkDateInputError;
    private _onClickOutside;
    private _onCalendarDateClick;
    private _onTimeClick;
    getValue(): Date | null;
    setValue(date_opt: any): void;
    getLocale(): string;
    setLocale(locale: any): void;
}
export default DateTime;
