import './polyfill';
import './deprecate';
import '../css/font.css';
import DateTime from './DateTime';
import Tabs from './Tabs';
import Text from './Text';
import ColorPicker from './ColorPicker';
import Table from './Table';
import createTableCell from './Table/TableCellFactory';
import Spinner from './Spinner';
import Button from './Button';
import Alert from './Alert';
import Label from './Label';
import IconButton from './IconButton';
import NotifyPopup from './NotifyPopup';
import MultipleChoice from './MultipleChoice';
import CheckBox from './CheckBox';
import RadioButton from './RadioButton';
import Dropdown from './Dropdown';
import Dialog from './Dialog';
import TextArea from './TextArea';
import Attachment from './Attachment';
import FieldGroup from './FieldGroup';
declare const kintoneUIComponent: {
    Alert: typeof Alert;
    Label: typeof Label;
    Button: typeof Button;
    IconButton: typeof IconButton;
    Text: typeof Text;
    Dropdown: typeof Dropdown;
    DateTime: typeof DateTime;
    NotifyPopup: typeof NotifyPopup;
    MultipleChoice: typeof MultipleChoice;
    RadioButton: typeof RadioButton;
    CheckBox: typeof CheckBox;
    Spinner: typeof Spinner;
    Table: typeof Table;
    FieldGroup: typeof FieldGroup;
    Dialog: typeof Dialog;
    TextArea: typeof TextArea;
    Attachment: typeof Attachment;
    createTableCell: (type: string, fieldName: string, props?: any) => import("./Table/TableCell").default;
    Tabs: typeof Tabs;
    ColorPicker: typeof ColorPicker;
};
export default kintoneUIComponent;
export { Alert, Label, Button, IconButton, Text, Dropdown, DateTime, NotifyPopup, MultipleChoice, RadioButton, CheckBox, Spinner, Table, FieldGroup, Dialog, TextArea, Attachment, createTableCell, Tabs, ColorPicker };
