/// <reference types="react" />
import '../../js/deprecate';
import '../../css/DateTime.css';
import '../../css/Text.css';
import Calendar from './components/Calendar';
import '../../css/font.css';
type DateTimeConstructorParameters = {
    value?: Date;
    onChange?: (newDate: Date | null) => void;
    locale?: 'ja' | 'en' | 'zh';
    dateFormat?: string;
    type?: 'date' | 'time' | 'datetime';
    timeFormat?: string;
    isDisabled?: boolean;
    isVisible?: boolean;
};
declare const DateTime: ({ value, isDisabled, isVisible, onChange, locale, dateFormat, type, timeFormat }: DateTimeConstructorParameters) => JSX.Element;
export default DateTime;
export { DateTimeConstructorParameters, Calendar };
export { en, zh, ja, format, getSeperator, } from './components/Locale';
export { availableLocales } from './components/DateTimeConstant';
