/// <reference types="react" />
import '../../js/deprecate';
import '../../css/font.css';
import '../../css/Table.css';
type DispatchParams = {
    type?: string;
    data?: Array<Record<string, any>>;
    rowIndex?: number;
    fieldName?: string;
};
type OnChangeCallbackParams = {
    rowIndex: number;
    data: Array<Record<string, any>>;
    fieldName: string;
};
type HandlerFunction = (newValue: any, tableData?: Array<Record<string, any>>, rowIndex?: number, fieldName?: string) => void;
type TableColumn = {
    header: string;
    tdProps?: (cellProps: CellRendererProps) => Record<string, any>;
    cell: (cellProps: CellRendererProps) => string | JSX.Element;
};
type ActionFlag = {
    actions: boolean;
};
type TableProps = {
    data?: Array<Record<string, any>>;
    columns?: Array<TableColumn | ActionFlag>;
    defaultRowData?: Record<string, any>;
    onRowAdd?: (newState: DispatchParams) => void;
    onRowRemove?: (newState: DispatchParams) => void;
    onCellChange?: (eventOptions: OnChangeCallbackParams) => void;
    actionButtonsShown?: boolean;
    isVisible?: boolean;
};
type CellRendererProps = {
    rowData?: Record<string, unknown>;
    rowIndex?: number;
    columnIndex?: number;
    onCellChange?: HandlerFunction;
};
type RowEventProps = {
    data?: Array<Record<string, unknown>>;
    rowIndex: number;
    defaultRowData?: Record<string, unknown>;
};
declare const Table: ({ data, columns, defaultRowData, onRowAdd, onRowRemove, onCellChange, actionButtonsShown, isVisible }: TableProps) => JSX.Element;
export default Table;
export { Table, TableColumn, CellRendererProps, ActionFlag, RowEventProps };
