var _handleItemClick = function (data, onChange) {
    var value = data.value || '';
    onChange && onChange(value);
};
var _hasDuplicatedItems = function (listItems) {
    if (!listItems) {
        return false;
    }
    var values = [];
    var isDuplicated = false;
    for (var i = 0; i < listItems.length; i++) {
        if (values.indexOf(listItems[i].value) >= 0) {
            isDuplicated = true;
            break;
        }
        values.push(listItems[i].value);
    }
    return isDuplicated;
};
var _hasValidItems = function (listItems) {
    if (!listItems) {
        return true;
    }
    return Array.isArray(listItems) && listItems.every(function (data) {
        return data.value !== undefined;
    });
};
var _hasValidValue = function (listItems, value) {
    if (value === undefined) {
        return true;
    }
    return listItems && listItems.some(function (data) {
        return data.value === value;
    });
};
export default { _handleItemClick: _handleItemClick, _hasDuplicatedItems: _hasDuplicatedItems, _hasValidItems: _hasValidItems, _hasValidValue: _hasValidValue };
